//-----------------------------------------------------------------------------
// CWindow
//
// This class is an interface for the operative system's windows.
//
// To compile with this class you must link with:
// user32.lib gdi32.lib
//
// Copyright (c) 2001 Andreas Jnsson
//-----------------------------------------------------------------------------
#ifndef WINDOW_H
#define WINDOW_H

#define STRICT				// Enable strict type checking
#define WIN32_LEAN_AND_MEAN // Don't include stuff that are rarely used
#include <windows.h>

class CWindow
{
public:
	struct SParameters
	{
		HINSTANCE hInstance;
		bool      fullscreen;
		int       width;
		int       height;
		char     *pMenu;
		char     *pTitle;
	};

	CWindow();

	void    SetDefault(SParameters *pParams);
	HRESULT Initialize(SParameters &params);
	bool    CheckMessage(bool wait);

	HWND    GetHandle();

	void    GetClientRect(RECT *pRect);

protected:
	HWND hWnd;
	bool fullscreen;

private:
	HWND   originalHWnd;
	UINT   originalMsg;
	WPARAM originalWParam;
	LPARAM originalLParam;

    LRESULT MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

	static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
};

#endif